image: mvdan/fdroid-ci:client-20160516

cache:
  paths:
    - .gradle/wrapper
    - .gradle/caches

test:
  script:
    - export GRADLE_USER_HOME=$PWD/.gradle
    - ./gradlew assemble -PdisablePreDex
    # always report on lint errors to the build log
    - sed -i -e 's,textReport .*,textReport true,' app/build.gradle
    - ./gradlew lint -PdisablePreDex
    - ./gradlew test -PdisablePreDex || {
          for log in app/build/reports/*ests/*/*ml; do
              echo "read $log here:";
              cat "$log" | curl --silent -F 'clbin=<-' https://clbin.com;
          done;
          exit 1;
      }
    # this file changes every time but should not be cached
    - rm -f $GRADLE_USER_HOME/caches/modules-2/modules-2.lock

connected10:
  variables:
    AVD_SDK: "10"
  script:
    - export GRADLE_USER_HOME=$PWD/.gradle
    - emulator64-arm -avd fcl-test-$AVD_SDK -no-skin -no-audio -no-window &
    - ./tools/wait-for-emulator
    - adb shell input keyevent 82 &
    - export EXITVALUE=0
    - ./gradlew connectedCheck -PdisablePreDex || {
        adb -e logcat -d '*:E';
        echo "get the full logcat here:";
        adb -e logcat -d | curl --silent -F 'clbin=<-' https://clbin.com;
        export EXITVALUE=1;
      }
    - for log in app/build/reports/*ests/*/*ml
                 app/build/outputs/*results*/connected/*.xml; do
        echo "read $log here:";
        cat "$log" | curl --silent -F 'clbin=<-' https://clbin.com;
      done
    # this file changes every time but should not be cached
    - rm -f $GRADLE_USER_HOME/caches/modules-2/modules-2.lock
    - exit $EXITVALUE
  allow_failure: true  # remove once install segfaults are gone

connected17:
  variables:
    AVD_SDK: "17"
  script:
    - export GRADLE_USER_HOME=$PWD/.gradle
    - emulator64-arm -avd fcl-test-$AVD_SDK -no-skin -no-audio -no-window &
    - ./tools/wait-for-emulator
    - adb shell input keyevent 82 &
    - export EXITVALUE=0
    - ./gradlew connectedCheck -PdisablePreDex || {
        adb -e logcat -d '*:E';
        echo "get the full logcat here:";
        adb -e logcat -d | curl --silent -F 'clbin=<-' https://clbin.com;
        export EXITVALUE=1;
      }
    - for log in app/build/reports/*ests/*/*ml
                 app/build/outputs/*results*/connected/*.xml; do
        echo "read $log here:";
        cat "$log" | curl --silent -F 'clbin=<-' https://clbin.com;
      done
    # this file changes every time but should not be cached
    - rm -f $GRADLE_USER_HOME/caches/modules-2/modules-2.lock
    - exit $EXITVALUE

pmd:
  script:
    - export GRADLE_USER_HOME=$PWD/.gradle
    - ./gradlew pmd -PdisablePreDex
    # this file changes every time but should not be cached
    - rm -f $GRADLE_USER_HOME/caches/modules-2/modules-2.lock

checkstyle:
  script:
    - export GRADLE_USER_HOME=$PWD/.gradle
    - ./gradlew checkstyle -PdisablePreDex
    # this file changes every time but should not be cached
    - rm -f $GRADLE_USER_HOME/caches/modules-2/modules-2.lock

tools:
  script:
    - cd app
    - ./tools/langs-list-check.py
    - ./tools/check-string-format.py
